
package org.objectweb.fractal.comete.gen;

import org.objectweb.fractal.cecilia.adl.file.CodeWriter;

/**
 * Class for code generation of a primitive C structure
 */
public class DeploymentPrimitiveStruct {
  String instanceName = null;
  String defName      = null;
  String pe           = null;
  String structName   = null;

  /**
   * Constructor
   * 
   * @param instanceName instance name of the sub-component
   * @param defName definition name of the sub-component
   * @param structName name of the C structure describing this sub-component
   * @param pe the processing element where the primitive must be deployed
   */
  public DeploymentPrimitiveStruct(final String instanceName,
      final String defName, final String structName, final String pe) {
    this.instanceName = instanceName;
    this.structName = structName;
    this.defName = defName;
    this.pe = pe;
  }

  /**
   * Generate the C code for this structure
   * 
   * @return the C code
   */
  public String getSource() {
    final CodeWriter cw = new CodeWriter();

    cw.appendln("static primitive_t " + structName + " = {{PRIMITIVE, \""
        + instanceName + "\"}, \"" + defName + "\", " + pe + "};");
    cw.endl();

    return cw.toString();
  }
}
